Index: uspace/lib/pcut/src/assert.c
===================================================================
--- uspace/lib/pcut/src/assert.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/pcut/src/assert.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -35,10 +35,6 @@
  */
 
-/*
- * We need _BSD_SOURCE because of vsnprintf() when compiling under C89.
- * In newer versions of features.h, _DEFAULT_SOURCE must be defined as well.
- */
+/** We need _BSD_SOURCE because of vsnprintf() when compiling under C89. */
 #define _BSD_SOURCE
-#define _DEFAULT_SOURCE
 
 #include "internal.h"
Index: uspace/lib/pcut/src/internal.h
===================================================================
--- uspace/lib/pcut/src/internal.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/pcut/src/internal.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -79,4 +79,14 @@
 #define PCUT_RUN_MODE_SINGLE 2
 
+/** Test outcome: test passed. */
+#define TEST_OUTCOME_PASS 1
+
+/** Test outcome: test failed. */
+#define TEST_OUTCOME_FAIL 2
+
+/** Test outcome: test failed unexpectedly. */
+#define TEST_OUTCOME_ERROR 3
+
+
 /*
  * Use sprintf_s in Windows but only with Microsoft compiler.
@@ -99,5 +109,5 @@
 int pcut_is_arg_with_number(const char *arg, const char *opt, int *value);
 
-int pcut_run_test_forking(const char *self_path, pcut_item_t *test);
+void pcut_run_test_forking(const char *self_path, pcut_item_t *test);
 int pcut_run_test_forked(pcut_item_t *test);
 int pcut_run_test_single(pcut_item_t *test);
@@ -125,5 +135,5 @@
 	/** Test completed. */
 	void (*test_done)(pcut_item_t *, int, const char *, const char *,
-	    const char *);
+		const char *);
 };
 
@@ -135,8 +145,8 @@
 void pcut_report_test_start(pcut_item_t *test);
 void pcut_report_test_done(pcut_item_t *test, int outcome,
-    const char *error_message, const char *teardown_error_message,
-    const char *extra_output);
+		const char *error_message, const char *teardown_error_message,
+		const char *extra_output);
 void pcut_report_test_done_unparsed(pcut_item_t *test, int outcome,
-    const char *unparsed_output, size_t unparsed_output_size);
+		const char *unparsed_output, size_t unparsed_output_size);
 void pcut_report_done(void);
 
Index: uspace/lib/pcut/src/main.c
===================================================================
--- uspace/lib/pcut/src/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/pcut/src/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -90,11 +90,8 @@
  * @param last Pointer to first item after this suite is stored here.
  * @param prog_path Path to the current binary (used in forked mode).
- * @return Error code.
- */
-static int run_suite(pcut_item_t *suite, pcut_item_t **last, const char *prog_path) {
+ */
+static void run_suite(pcut_item_t *suite, pcut_item_t **last, const char *prog_path) {
 	int is_first_test = 1;
 	int total_count = 0;
-	int ret_code = PCUT_OUTCOME_PASS;
-	int ret_code_tmp;
 
 	pcut_item_t *it = pcut_get_real_next(suite);
@@ -117,19 +114,8 @@
 
 		if (pcut_run_mode == PCUT_RUN_MODE_FORKING) {
-			ret_code_tmp = pcut_run_test_forking(prog_path, it);
-		} else {
-			ret_code_tmp = pcut_run_test_single(it);
-		}
-
-		/*
-		 * Override final return code in case of failure.
-		 *
-		 * In this case we suppress any special error codes as
-		 * to the outside, there was a failure.
-		 */
-		if (ret_code_tmp != PCUT_OUTCOME_PASS) {
-			ret_code = PCUT_OUTCOME_FAIL;
-		}
-
+			pcut_run_test_forking(prog_path, it);
+		} else {
+			pcut_run_test_single(it);
+		}
 		total_count++;
 	}
@@ -144,6 +130,4 @@
 		*last = it;
 	}
-
-	return ret_code;
 }
 
@@ -197,6 +181,4 @@
 	int run_only_test = -1;
 
-	int rc, rc_tmp;
-
 	if (main_extras == NULL) {
 		main_extras = empty_main_extra;
@@ -221,5 +203,5 @@
 			if (pcut_str_equals(argv[i], "-l")) {
 				pcut_print_tests(items);
-				return PCUT_OUTCOME_PASS;
+				return 0;
 			}
 			if (pcut_str_equals(argv[i], "-x")) {
@@ -247,5 +229,5 @@
 	if ((run_only_suite >= 0) && (run_only_test >= 0)) {
 		printf("Specify either -s or -t!\n");
-		return PCUT_OUTCOME_BAD_INVOCATION;
+		return 1;
 	}
 
@@ -254,24 +236,25 @@
 		if (suite == NULL) {
 			printf("Suite not found, aborting!\n");
-			return PCUT_OUTCOME_BAD_INVOCATION;
+			return 2;
 		}
 		if (suite->kind != PCUT_KIND_TESTSUITE) {
 			printf("Invalid suite id!\n");
-			return PCUT_OUTCOME_BAD_INVOCATION;
+			return 3;
 		}
 
 		run_suite(suite, NULL, argv[0]);
-		return PCUT_OUTCOME_PASS;
+		return 0;
 	}
 
 	if (run_only_test > 0) {
+		int rc;
 		pcut_item_t *test = pcut_find_by_id(items, run_only_test);
 		if (test == NULL) {
 			printf("Test not found, aborting!\n");
-			return PCUT_OUTCOME_BAD_INVOCATION;
+			return 2;
 		}
 		if (test->kind != PCUT_KIND_TEST) {
 			printf("Invalid test id!\n");
-			return PCUT_OUTCOME_BAD_INVOCATION;
+			return 3;
 		}
 
@@ -287,6 +270,4 @@
 	/* Otherwise, run the whole thing. */
 	pcut_report_init(items);
-
-	rc = PCUT_OUTCOME_PASS;
 
 	it = items;
@@ -294,8 +275,5 @@
 		if (it->kind == PCUT_KIND_TESTSUITE) {
 			pcut_item_t *tmp;
-			rc_tmp = run_suite(it, &tmp, argv[0]);
-			if (rc_tmp != PCUT_OUTCOME_PASS) {
-				rc = rc_tmp;
-			}
+			run_suite(it, &tmp, argv[0]);
 			it = tmp;
 		} else {
@@ -306,4 +284,4 @@
 	pcut_report_done();
 
-	return rc;
-}
+	return 0;
+}
Index: uspace/lib/pcut/src/os/generic.c
===================================================================
--- uspace/lib/pcut/src/os/generic.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/pcut/src/os/generic.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -34,5 +34,4 @@
 #include <stdlib.h>
 #include <stdio.h>
-#include <sys/types.h>
 #include <errno.h>
 #include <assert.h>
@@ -95,9 +94,9 @@
 static int convert_wait_status_to_outcome(int status) {
 	if (status < 0) {
-		return PCUT_OUTCOME_INTERNAL_ERROR;
+		return TEST_OUTCOME_ERROR;
 	} else if (status == 0) {
-		return PCUT_OUTCOME_PASS;
+		return TEST_OUTCOME_PASS;
 	} else {
-		return PCUT_OUTCOME_FAIL;
+		return TEST_OUTCOME_FAIL;
 	}
 }
@@ -108,6 +107,6 @@
  * @param test Test to be run.
  */
-int pcut_run_test_forking(const char *self_path, pcut_item_t *test) {
-	int rc, outcome;
+void pcut_run_test_forking(const char *self_path, pcut_item_t *test) {
+	int rc;
 	FILE *tempfile;
 	char tempfile_name[PCUT_TEMP_FILENAME_BUFFER_SIZE];
@@ -127,19 +126,17 @@
 	PCUT_DEBUG("system() returned 0x%04X", rc);
 
-	outcome = convert_wait_status_to_outcome(rc);
+	rc = convert_wait_status_to_outcome(rc);
 
 	tempfile = fopen(tempfile_name, "rb");
 	if (tempfile == NULL) {
 		pcut_report_test_done(test, TEST_OUTCOME_ERROR, "Failed to open temporary file.", NULL, NULL);
-		return PCUT_OUTCOME_INTERNAL_ERROR;
+		return;
 	}
 
 	fread(extra_output_buffer, 1, OUTPUT_BUFFER_SIZE, tempfile);
 	fclose(tempfile);
-	remove(tempfile_name);
+	unlink(tempfile_name);
 
-	pcut_report_test_done_unparsed(test, outcome, extra_output_buffer, OUTPUT_BUFFER_SIZE);
-
-	return outcome;
+	pcut_report_test_done_unparsed(test, rc, extra_output_buffer, OUTPUT_BUFFER_SIZE);
 }
 
Index: uspace/lib/pcut/src/os/helenos.c
===================================================================
--- uspace/lib/pcut/src/os/helenos.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/pcut/src/os/helenos.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -68,5 +68,5 @@
 }
 
-void pcut_str_error(errno_t error, char *buffer, int size) {
+void pcut_str_error(int error, char *buffer, int size) {
 	const char *str = str_error(error);
 	if (str == NULL) {
@@ -130,5 +130,5 @@
  * @return EOK Always.
  */
-static errno_t test_timeout_handler_fibril(void *arg) {
+static int test_timeout_handler_fibril(void *arg) {
 	pcut_item_t *test = arg;
 	int timeout_sec = pcut_get_test_timeout(test);
@@ -139,5 +139,5 @@
 		goto leave_no_kill;
 	}
-	errno_t rc = fibril_condvar_wait_timeout(&forced_termination_cv,
+	int rc = fibril_condvar_wait_timeout(&forced_termination_cv,
 		&forced_termination_mutex, timeout_us);
 	if (rc == ETIMEOUT) {
@@ -154,14 +154,13 @@
  * @param test Test to be run.
  */
-int pcut_run_test_forking(const char *self_path, pcut_item_t *test) {
+void pcut_run_test_forking(const char *self_path, pcut_item_t *test) {
 	before_test_start(test);
 
 	char tempfile_name[PCUT_TEMP_FILENAME_BUFFER_SIZE];
 	snprintf(tempfile_name, PCUT_TEMP_FILENAME_BUFFER_SIZE - 1, "pcut_%lld.tmp", (unsigned long long) task_get_id());
-	int tempfile;
-	errno_t rc = vfs_lookup_open(tempfile_name, WALK_REGULAR | WALK_MAY_CREATE, MODE_READ | MODE_WRITE, &tempfile);
-	if (rc != EOK) {
-		pcut_report_test_done(test, PCUT_OUTCOME_INTERNAL_ERROR, "Failed to create temporary file.", NULL, NULL);
-		return PCUT_OUTCOME_INTERNAL_ERROR;
+	int tempfile = vfs_lookup_open(tempfile_name, WALK_REGULAR | WALK_MAY_CREATE, MODE_READ | MODE_WRITE);
+	if (tempfile < 0) {
+		pcut_report_test_done(test, TEST_OUTCOME_ERROR, "Failed to create temporary file.", NULL, NULL);
+		return;
 	}
 
@@ -175,11 +174,11 @@
 	};
 
-	int status = PCUT_OUTCOME_PASS;
+	int status = TEST_OUTCOME_PASS;
 
 	task_wait_t test_task_wait;
-	rc = task_spawnvf(&test_task_id, &test_task_wait, self_path, arguments,
+	int rc = task_spawnvf(&test_task_id, &test_task_wait, self_path, arguments,
 	    fileno(stdin), tempfile, tempfile);
 	if (rc != EOK) {
-		status = PCUT_OUTCOME_INTERNAL_ERROR;
+		status = TEST_OUTCOME_ERROR;
 		goto leave_close_tempfile;
 	}
@@ -199,11 +198,11 @@
 	rc = task_wait(&test_task_wait, &task_exit, &task_retval);
 	if (rc != EOK) {
-		status = PCUT_OUTCOME_INTERNAL_ERROR;
+		status = TEST_OUTCOME_ERROR;
 		goto leave_close_tempfile;
 	}
 	if (task_exit == TASK_EXIT_UNEXPECTED) {
-		status = PCUT_OUTCOME_INTERNAL_ERROR;
+		status = TEST_OUTCOME_ERROR;
 	} else {
-		status = task_retval == 0 ? PCUT_OUTCOME_PASS : PCUT_OUTCOME_FAIL;
+		status = task_retval == 0 ? TEST_OUTCOME_PASS : TEST_OUTCOME_FAIL;
 	}
 
@@ -222,6 +221,4 @@
 
 	pcut_report_test_done_unparsed(test, status, extra_output_buffer, OUTPUT_BUFFER_SIZE);
-
-	return status;
 }
 
Index: uspace/lib/pcut/src/os/unix.c
===================================================================
--- uspace/lib/pcut/src/os/unix.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/pcut/src/os/unix.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,11 +36,7 @@
 /** We need _BSD_SOURCE because of snprintf() when compiling under C89. */
 #define _BSD_SOURCE
-
-/** Newer versions of features.h needs _DEFAULT_SOURCE. */
-#define _DEFAULT_SOURCE
-
 #include <stdlib.h>
 #include <unistd.h>
-#include <sys/types.h>
+#include <stddef.h>
 #include <signal.h>
 #include <errno.h>
@@ -124,12 +120,12 @@
 	if (WIFEXITED(status)) {
 		if (WEXITSTATUS(status) != 0) {
-			return PCUT_OUTCOME_FAIL;
+			return TEST_OUTCOME_FAIL;
 		} else {
-			return PCUT_OUTCOME_PASS;
+			return TEST_OUTCOME_PASS;
 		}
 	}
 
 	if (WIFSIGNALED(status)) {
-		return PCUT_OUTCOME_INTERNAL_ERROR;
+		return TEST_OUTCOME_ERROR;
 	}
 
@@ -142,7 +138,7 @@
  * @param test Test to be run.
  */
-int pcut_run_test_forking(const char *self_path, pcut_item_t *test) {
+void pcut_run_test_forking(const char *self_path, pcut_item_t *test) {
 	int link_stdout[2], link_stderr[2];
-	int rc, status, outcome;
+	int rc, status;
 	size_t stderr_size;
 
@@ -156,6 +152,6 @@
 		snprintf(error_message_buffer, OUTPUT_BUFFER_SIZE - 1,
 				"pipe() failed: %s.", strerror(rc));
-		pcut_report_test_done(test, PCUT_OUTCOME_INTERNAL_ERROR, error_message_buffer, NULL, NULL);
-		return PCUT_OUTCOME_INTERNAL_ERROR;
+		pcut_report_test_done(test, TEST_OUTCOME_ERROR, error_message_buffer, NULL, NULL);
+		return;
 	}
 	rc = pipe(link_stderr);
@@ -163,6 +159,6 @@
 		snprintf(error_message_buffer, OUTPUT_BUFFER_SIZE - 1,
 				"pipe() failed: %s.", strerror(rc));
-		pcut_report_test_done(test, PCUT_OUTCOME_INTERNAL_ERROR, error_message_buffer, NULL, NULL);
-		return PCUT_OUTCOME_INTERNAL_ERROR;
+		pcut_report_test_done(test, TEST_OUTCOME_ERROR, error_message_buffer, NULL, NULL);
+		return;
 	}
 
@@ -171,5 +167,5 @@
 		snprintf(error_message_buffer, OUTPUT_BUFFER_SIZE - 1,
 			"fork() failed: %s.", strerror(rc));
-		outcome = PCUT_OUTCOME_INTERNAL_ERROR;
+		rc = TEST_OUTCOME_ERROR;
 		goto leave_close_pipes;
 	}
@@ -182,7 +178,7 @@
 		close(link_stderr[0]);
 
-		outcome = pcut_run_test_forked(test);
-
-		exit(outcome);
+		rc = pcut_run_test_forked(test);
+
+		exit(rc);
 	}
 
@@ -199,5 +195,5 @@
 	alarm(0);
 
-	outcome = convert_wait_status_to_outcome(status);
+	rc = convert_wait_status_to_outcome(status);
 
 	goto leave_close_parent_pipe;
@@ -210,7 +206,5 @@
 	close(link_stderr[0]);
 
-	pcut_report_test_done_unparsed(test, outcome, extra_output_buffer, OUTPUT_BUFFER_SIZE);
-
-	return outcome;
+	pcut_report_test_done_unparsed(test, rc, extra_output_buffer, OUTPUT_BUFFER_SIZE);
 }
 
Index: uspace/lib/pcut/src/os/windows.c
===================================================================
--- uspace/lib/pcut/src/os/windows.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/pcut/src/os/windows.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -144,5 +144,5 @@
  * @param test Test to be run.
  */
-int pcut_run_test_forking(const char *self_path, pcut_item_t *test) {
+void pcut_run_test_forking(const char *self_path, pcut_item_t *test) {
 	/* TODO: clean-up if something goes wrong "in the middle" */
 	BOOL okay = FALSE;
@@ -173,10 +173,10 @@
 	if (!okay) {
 		report_func_fail(test, "CreatePipe(/* stdout */)");
-		return PCUT_OUTCOME_INTERNAL_ERROR;
+		return;
 	}
 	okay = SetHandleInformation(link_stdout[0], HANDLE_FLAG_INHERIT, 0);
 	if (!okay) {
 		report_func_fail(test, "SetHandleInformation(/* stdout */)");
-		return PCUT_OUTCOME_INTERNAL_ERROR;
+		return;
 	}
 
@@ -185,10 +185,10 @@
 	if (!okay) {
 		report_func_fail(test, "CreatePipe(/* stderr */)");
-		return PCUT_OUTCOME_INTERNAL_ERROR;
+		return;
 	}
 	okay = SetHandleInformation(link_stderr[0], HANDLE_FLAG_INHERIT, 0);
 	if (!okay) {
 		report_func_fail(test, "SetHandleInformation(/* stderr */)");
-		return PCUT_OUTCOME_INTERNAL_ERROR;
+		return;
 	}
 
@@ -197,10 +197,10 @@
 	if (!okay) {
 		report_func_fail(test, "CreatePipe(/* stdin */)");
-		return PCUT_OUTCOME_INTERNAL_ERROR;
+		return;
 	}
 	okay = SetHandleInformation(link_stdin[1], HANDLE_FLAG_INHERIT, 0);
 	if (!okay) {
 		report_func_fail(test, "SetHandleInformation(/* stdin */)");
-		return PCUT_OUTCOME_INTERNAL_ERROR;
+		return;
 	}
 
@@ -224,5 +224,5 @@
 	if (!okay) {
 		report_func_fail(test, "CreateProcess()");
-		return PCUT_OUTCOME_INTERNAL_ERROR;
+		return;
 	}
 
@@ -236,15 +236,15 @@
 	if (!okay) {
 		report_func_fail(test, "CloseHandle(/* stdout */)");
-		return PCUT_OUTCOME_INTERNAL_ERROR;
+		return;
 	}
 	okay = CloseHandle(link_stderr[1]);
 	if (!okay) {
 		report_func_fail(test, "CloseHandle(/* stderr */)");
-		return PCUT_OUTCOME_INTERNAL_ERROR;
+		return;
 	}
 	okay = CloseHandle(link_stdin[0]);
 	if (!okay) {
 		report_func_fail(test, "CloseHandle(/* stdin */)");
-		return PCUT_OUTCOME_INTERNAL_ERROR;
+		return;
 	}
 
@@ -267,5 +267,5 @@
 	if (test_output_thread_reader == NULL) {
 		report_func_fail(test, "CreateThread(/* read test stdout */)");
-		return PCUT_OUTCOME_INTERNAL_ERROR;
+		return;
 	}
 
@@ -281,5 +281,5 @@
 		if (!okay) {
 			report_func_fail(test, "TerminateProcess(/* PROCESS_INFORMATION.hProcess */)");
-			return PCUT_ERROR_INTERNAL_FAILURE;
+			return;
 		}
 		rc = WaitForSingleObject(process_info.hProcess, INFINITE);
@@ -287,5 +287,5 @@
 	if (rc != WAIT_OBJECT_0) {
 		report_func_fail(test, "WaitForSingleObject(/* PROCESS_INFORMATION.hProcess */)");
-		return PCUT_OUTCOME_INTERNAL_ERROR;
+		return;
 	}
 
@@ -294,13 +294,13 @@
 	if (!okay) {
 		report_func_fail(test, "GetExitCodeProcess()");
-		return PCUT_OUTCOME_INTERNAL_ERROR;
+		return;
 	}
 
 	if (rc == 0) {
-		outcome = PCUT_OUTCOME_PASS;
+		outcome = TEST_OUTCOME_PASS;
 	} else if ((rc > 0) && (rc < 10) && !timed_out) {
-		outcome = PCUT_OUTCOME_FAIL;
+		outcome = TEST_OUTCOME_FAIL;
 	} else {
-		outcome = PCUT_OUTCOME_INTERNAL_ERROR;
+		outcome = TEST_OUTCOME_ERROR;
 	}
 
@@ -309,10 +309,8 @@
 	if (rc != WAIT_OBJECT_0) {
 		report_func_fail(test, "WaitForSingleObject(/* stdout reader thread */)");
-		return PCUT_ERROR_INTERNAL_FAILURE;
+		return;
 	}
 
 	pcut_report_test_done_unparsed(test, outcome, extra_output_buffer, OUTPUT_BUFFER_SIZE);
-
-	return outcome;
 }
 
Index: uspace/lib/pcut/src/print.c
===================================================================
--- uspace/lib/pcut/src/print.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/pcut/src/print.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -81,8 +81,4 @@
 			printf("    Test `%s' [%d]\n", it->name, it->id);
 			break;
-		case PCUT_KIND_SETUP:
-		case PCUT_KIND_TEARDOWN:
-			/* Fall-through, do nothing. */
-			break;
 		default:
 			assert(0 && "unreachable case in item-kind switch");
Index: uspace/lib/pcut/src/report/report.c
===================================================================
--- uspace/lib/pcut/src/report/report.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/pcut/src/report/report.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -33,7 +33,5 @@
 
 #include "../internal.h"
-#ifdef __helenos__
-#include <str.h>
-#else
+#ifndef __helenos__
 #include <string.h>
 #endif
Index: uspace/lib/pcut/src/report/tap.c
===================================================================
--- uspace/lib/pcut/src/report/tap.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/pcut/src/report/tap.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,7 +42,4 @@
 static int test_counter;
 
-/** Counter of all failures. */
-static int failed_test_counter;
-
 /** Counter for tests in a current suite. */
 static int tests_in_suite;
@@ -58,5 +55,4 @@
 	int tests_total = pcut_count_tests(all_items);
 	test_counter = 0;
-	failed_test_counter = 0;
 
 	printf("1..%d\n", tests_total);
@@ -79,11 +75,6 @@
  */
 static void tap_suite_done(pcut_item_t *suite) {
-	if (failed_tests_in_suite == 0) {
-		printf("#> Finished suite %s (passed).\n",
-				suite->name);
-	} else {
-		printf("#> Finished suite %s (failed %d of %d).\n",
-				suite->name, failed_tests_in_suite, tests_in_suite);
-	}
+	printf("#> Finished suite %s (failed %d of %d).\n",
+			suite->name, failed_tests_in_suite, tests_in_suite);
 }
 
@@ -138,21 +129,23 @@
 	const char *fail_error_str = NULL;
 
-	if (outcome != PCUT_OUTCOME_PASS) {
+	if (outcome != TEST_OUTCOME_PASS) {
 		failed_tests_in_suite++;
-		failed_test_counter++;
 	}
 
 	switch (outcome) {
-	case PCUT_OUTCOME_PASS:
+	case TEST_OUTCOME_PASS:
 		status_str = "ok";
 		fail_error_str = "";
 		break;
-	case PCUT_OUTCOME_FAIL:
+	case TEST_OUTCOME_FAIL:
 		status_str = "not ok";
 		fail_error_str = " failed";
 		break;
-	default:
+	case TEST_OUTCOME_ERROR:
 		status_str = "not ok";
 		fail_error_str = " aborted";
+		break;
+	default:
+		/* Shall not get here. */
 		break;
 	}
@@ -167,9 +160,4 @@
 /** Report testing done. */
 static void tap_done(void) {
-	if (failed_test_counter == 0) {
-		printf("#> Done: all tests passed.\n");
-	} else {
-		printf("#> Done: %d of %d tests failed.\n", failed_test_counter, test_counter);
-	}
 }
 
Index: uspace/lib/pcut/src/report/xml.c
===================================================================
--- uspace/lib/pcut/src/report/xml.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/pcut/src/report/xml.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -135,17 +135,20 @@
 	const char *status_str = NULL;
 
-	if (outcome != PCUT_OUTCOME_PASS) {
+	if (outcome != TEST_OUTCOME_PASS) {
 		failed_tests_in_suite++;
 	}
 
 	switch (outcome) {
-	case PCUT_OUTCOME_PASS:
+	case TEST_OUTCOME_PASS:
 		status_str = "pass";
 		break;
-	case PCUT_OUTCOME_FAIL:
+	case TEST_OUTCOME_FAIL:
 		status_str = "fail";
 		break;
+	case TEST_OUTCOME_ERROR:
+		status_str = "error";
+		break;
 	default:
-		status_str = "error";
+		/* Shall not get here. */
 		break;
 	}
Index: uspace/lib/pcut/src/run.c
===================================================================
--- uspace/lib/pcut/src/run.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/pcut/src/run.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -73,8 +73,9 @@
 static int default_suite_initialized = 0;
 
-static void init_default_suite_when_needed() {
-	if (default_suite_initialized) {
+static void init_default_suite_when_needed(void)
+{
+	if (default_suite_initialized)
 		return;
-	}
+	
 	default_suite.id = -1;
 	default_suite.kind = PCUT_KIND_TESTSUITE;
@@ -91,11 +92,13 @@
  * @return Always a valid test suite item.
  */
-static pcut_item_t *pcut_find_parent_suite(pcut_item_t *it) {
+static pcut_item_t *pcut_find_parent_suite(pcut_item_t *it)
+{
 	while (it != NULL) {
-		if (it->kind == PCUT_KIND_TESTSUITE) {
+		if (it->kind == PCUT_KIND_TESTSUITE)
 			return it;
-		}
+		
 		it = it->previous;
 	}
+	
 	init_default_suite_when_needed();
 	return &default_suite;
@@ -106,8 +109,8 @@
  * @param func Function to run (can be NULL).
  */
-static void run_setup_teardown(pcut_setup_func_t func) {
-	if (func != NULL) {
+static void run_setup_teardown(pcut_setup_func_t func)
+{
+	if (func != NULL)
 		func();
-	}
 }
 
@@ -119,11 +122,11 @@
  * @param outcome Outcome of the current test.
  */
-static void leave_test(int outcome) {
+static void leave_test(int outcome)
+{
 	PCUT_DEBUG("leave_test(outcome=%d), will_exit=%s", outcome,
-		leave_means_exit ? "yes" : "no");
-	if (leave_means_exit) {
+	    leave_means_exit ? "yes" : "no");
+	if (leave_means_exit)
 		exit(outcome);
-	}
-
+	
 #ifndef PCUT_NO_LONG_JUMP
 	longjmp(start_test_jump, 1);
@@ -138,6 +141,8 @@
  * @param message Message describing the failure.
  */
-void pcut_failed_assertion(const char *message) {
+void pcut_failed_assertion(const char *message)
+{
 	static const char *prev_message = NULL;
+	
 	/*
 	 * The assertion failed. We need to abort the current test,
@@ -145,28 +150,27 @@
 	 * include running the tear-down routine.
 	 */
-	if (print_test_error) {
+	if (print_test_error)
 		pcut_print_fail_message(message);
-	}
-
+	
 	if (execute_teardown_on_failure) {
 		execute_teardown_on_failure = 0;
 		prev_message = message;
 		run_setup_teardown(current_suite->teardown_func);
-
+		
 		/* Tear-down was okay. */
 		if (report_test_result) {
-			pcut_report_test_done(current_test, PCUT_OUTCOME_FAIL,
+			pcut_report_test_done(current_test, TEST_OUTCOME_FAIL,
 				message, NULL, NULL);
 		}
 	} else {
 		if (report_test_result) {
-			pcut_report_test_done(current_test, PCUT_OUTCOME_FAIL,
+			pcut_report_test_done(current_test, TEST_OUTCOME_FAIL,
 				prev_message, message, NULL);
 		}
 	}
-
+	
 	prev_message = NULL;
-
-	leave_test(PCUT_OUTCOME_FAIL); /* No return. */
+	
+	leave_test(TEST_OUTCOME_FAIL); /* No return. */
 }
 
@@ -176,5 +180,6 @@
  * @return Error status (zero means success).
  */
-static int run_test(pcut_item_t *test) {
+static int run_test(pcut_item_t *test)
+{
 	/*
 	 * Set here as the returning point in case of test failure.
@@ -182,20 +187,19 @@
 	 * test execution.
 	 */
+	
 #ifndef PCUT_NO_LONG_JUMP
 	int test_finished = setjmp(start_test_jump);
-	if (test_finished) {
-		return PCUT_OUTCOME_FAIL;
-	}
+	if (test_finished)
+		return 1;
 #endif
-
-	if (report_test_result) {
+	
+	if (report_test_result)
 		pcut_report_test_start(test);
-	}
-
+	
 	current_suite = pcut_find_parent_suite(test);
 	current_test = test;
-
+	
 	pcut_hook_before_test(test);
-
+	
 	/*
 	 * If anything goes wrong, execute the tear-down function
@@ -203,10 +207,10 @@
 	 */
 	execute_teardown_on_failure = 1;
-
+	
 	/*
 	 * Run the set-up function.
 	 */
 	run_setup_teardown(current_suite->setup_func);
-
+	
 	/*
 	 * The setup function was performed, it is time to run
@@ -214,5 +218,5 @@
 	 */
 	test->test_func();
-
+	
 	/*
 	 * Finally, run the tear-down function. We need to clear
@@ -221,15 +225,14 @@
 	execute_teardown_on_failure = 0;
 	run_setup_teardown(current_suite->teardown_func);
-
+	
 	/*
 	 * If we got here, it means everything went well with
 	 * this test.
 	 */
-	if (report_test_result) {
-		pcut_report_test_done(current_test, PCUT_OUTCOME_PASS,
-			NULL, NULL, NULL);
-	}
-
-	return PCUT_OUTCOME_PASS;
+	if (report_test_result)
+		pcut_report_test_done(current_test, TEST_OUTCOME_PASS,
+		    NULL, NULL, NULL);
+	
+	return 0;
 }
 
@@ -242,16 +245,15 @@
  * @return Error status (zero means success).
  */
-int pcut_run_test_forked(pcut_item_t *test) {
-	int rc;
-
+int pcut_run_test_forked(pcut_item_t *test)
+{
 	report_test_result = 0;
 	print_test_error = 1;
 	leave_means_exit = 1;
-
-	rc = run_test(test);
-
+	
+	int rc = run_test(test);
+	
 	current_test = NULL;
 	current_suite = NULL;
-
+	
 	return rc;
 }
@@ -265,16 +267,15 @@
  * @return Error status (zero means success).
  */
-int pcut_run_test_single(pcut_item_t *test) {
-	int rc;
-
+int pcut_run_test_single(pcut_item_t *test)
+{
 	report_test_result = 1;
 	print_test_error = 0;
 	leave_means_exit = 0;
-
-	rc = run_test(test);
-
+	
+	int rc = run_test(test);
+	
 	current_test = NULL;
 	current_suite = NULL;
-
+	
 	return rc;
 }
@@ -285,16 +286,16 @@
  * @return Timeout in seconds.
  */
-int pcut_get_test_timeout(pcut_item_t *test) {
+int pcut_get_test_timeout(pcut_item_t *test)
+{
 	int timeout = PCUT_DEFAULT_TEST_TIMEOUT;
 	pcut_extra_t *extras = test->extras;
-
-
+	
 	while (extras->type != PCUT_EXTRA_LAST) {
-		if (extras->type == PCUT_EXTRA_TIMEOUT) {
+		if (extras->type == PCUT_EXTRA_TIMEOUT)
 			timeout = extras->timeout;
-		}
+		
 		extras++;
 	}
-
+	
 	return timeout;
 }
Index: uspace/lib/pcut/tests/beforeafter.c
===================================================================
--- uspace/lib/pcut/tests/beforeafter.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/pcut/tests/beforeafter.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -28,5 +28,4 @@
 
 #define _BSD_SOURCE
-#define _DEFAULT_SOURCE
 
 #include <pcut/pcut.h>
Index: uspace/lib/pcut/tests/errno.c
===================================================================
--- uspace/lib/pcut/tests/errno.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/pcut/tests/errno.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,5 +38,5 @@
 
 PCUT_TEST(errno_value) {
-	errno_t value = EOK;
+	int value = EOK;
 	PCUT_ASSERT_ERRNO_VAL(EOK, value);
 	value = ENOENT;
Index: uspace/lib/pcut/tests/timeout.c
===================================================================
--- uspace/lib/pcut/tests/timeout.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/pcut/tests/timeout.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -29,13 +29,10 @@
 #include <pcut/pcut.h>
 
-#ifdef __helenos__
+#ifdef __unix
+// FIXME
 #include <thread.h>
-#else
-#ifdef __unix
-#include <unistd.h>
 #endif
 #if defined(__WIN64) || defined(__WIN32) || defined(_WIN32)
 #include <windows.h>
-#endif
 #endif
 
@@ -44,13 +41,10 @@
 
 static void my_sleep(int sec) {
-#ifdef __helenos__
+#ifdef __unix
+// FIXME
 	thread_sleep(sec);
-#else
-#ifdef __unix
-	sleep(sec);
 #endif
 #if defined(__WIN64) || defined(__WIN32) || defined(_WIN32)
 	Sleep(1000 * sec);
-#endif
 #endif
 }
Index: uspace/lib/pcut/tests/xmlreport.c
===================================================================
--- uspace/lib/pcut/tests/xmlreport.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/pcut/tests/xmlreport.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -30,6 +30,4 @@
 #include "tested.h"
 
-#include <pcut/pcut.h>
-#include "tested.h"
 
 PCUT_INIT
